/**
 */
package DNImaster.impl;

import DNImaster.Dependency;
import DNImaster.EntityAddress;
import DNImaster.GenericFlow;
import DNImaster.MasterPackage;
import DNImaster.SoftwareComponent;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Generic Flow</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getAlternativeNames <em>Alternative Names</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getName <em>Name</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getDestinationSoftwareComponent <em>Destination Software Component</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getSourceSoftwareComponent <em>Source Software Component</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getDestinationAddresses <em>Destination Addresses</em>}</li>
 *   <li>{@link DNImaster.impl.GenericFlowImpl#getDataSize <em>Data Size</em>}</li>
 * </ul>
 *
 * @generated
 */
public class GenericFlowImpl extends MinimalEObjectImpl.Container implements GenericFlow {
	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAlternativeNames() <em>Alternative Names</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAlternativeNames()
	 * @generated
	 * @ordered
	 */
	protected EList<String> alternativeNames;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDestinationSoftwareComponent() <em>Destination Software Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestinationSoftwareComponent()
	 * @generated
	 * @ordered
	 */
	protected SoftwareComponent destinationSoftwareComponent;

	/**
	 * The cached value of the '{@link #getSourceSoftwareComponent() <em>Source Software Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceSoftwareComponent()
	 * @generated
	 * @ordered
	 */
	protected SoftwareComponent sourceSoftwareComponent;

	/**
	 * The cached value of the '{@link #getDestinationAddresses() <em>Destination Addresses</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDestinationAddresses()
	 * @generated
	 * @ordered
	 */
	protected EList<EntityAddress> destinationAddresses;

	/**
	 * The cached value of the '{@link #getDataSize() <em>Data Size</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataSize()
	 * @generated
	 * @ordered
	 */
	protected Dependency dataSize;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GenericFlowImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MasterPackage.Literals.GENERIC_FLOW;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAlternativeNames() {
		if (alternativeNames == null) {
			alternativeNames = new EDataTypeUniqueEList<String>(String.class, this, MasterPackage.GENERIC_FLOW__ALTERNATIVE_NAMES);
		}
		return alternativeNames;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent getDestinationSoftwareComponent() {
		if (destinationSoftwareComponent != null && destinationSoftwareComponent.eIsProxy()) {
			InternalEObject oldDestinationSoftwareComponent = (InternalEObject)destinationSoftwareComponent;
			destinationSoftwareComponent = (SoftwareComponent)eResolveProxy(oldDestinationSoftwareComponent);
			if (destinationSoftwareComponent != oldDestinationSoftwareComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT, oldDestinationSoftwareComponent, destinationSoftwareComponent));
			}
		}
		return destinationSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent basicGetDestinationSoftwareComponent() {
		return destinationSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDestinationSoftwareComponent(SoftwareComponent newDestinationSoftwareComponent) {
		SoftwareComponent oldDestinationSoftwareComponent = destinationSoftwareComponent;
		destinationSoftwareComponent = newDestinationSoftwareComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT, oldDestinationSoftwareComponent, destinationSoftwareComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent getSourceSoftwareComponent() {
		if (sourceSoftwareComponent != null && sourceSoftwareComponent.eIsProxy()) {
			InternalEObject oldSourceSoftwareComponent = (InternalEObject)sourceSoftwareComponent;
			sourceSoftwareComponent = (SoftwareComponent)eResolveProxy(oldSourceSoftwareComponent);
			if (sourceSoftwareComponent != oldSourceSoftwareComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT, oldSourceSoftwareComponent, sourceSoftwareComponent));
			}
		}
		return sourceSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SoftwareComponent basicGetSourceSoftwareComponent() {
		return sourceSoftwareComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceSoftwareComponent(SoftwareComponent newSourceSoftwareComponent) {
		SoftwareComponent oldSourceSoftwareComponent = sourceSoftwareComponent;
		sourceSoftwareComponent = newSourceSoftwareComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT, oldSourceSoftwareComponent, sourceSoftwareComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EntityAddress> getDestinationAddresses() {
		if (destinationAddresses == null) {
			destinationAddresses = new EObjectContainmentEList<EntityAddress>(EntityAddress.class, this, MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES);
		}
		return destinationAddresses;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Dependency getDataSize() {
		return dataSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDataSize(Dependency newDataSize, NotificationChain msgs) {
		Dependency oldDataSize = dataSize;
		dataSize = newDataSize;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__DATA_SIZE, oldDataSize, newDataSize);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataSize(Dependency newDataSize) {
		if (newDataSize != dataSize) {
			NotificationChain msgs = null;
			if (dataSize != null)
				msgs = ((InternalEObject)dataSize).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MasterPackage.GENERIC_FLOW__DATA_SIZE, null, msgs);
			if (newDataSize != null)
				msgs = ((InternalEObject)newDataSize).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MasterPackage.GENERIC_FLOW__DATA_SIZE, null, msgs);
			msgs = basicSetDataSize(newDataSize, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MasterPackage.GENERIC_FLOW__DATA_SIZE, newDataSize, newDataSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES:
				return ((InternalEList<?>)getDestinationAddresses()).basicRemove(otherEnd, msgs);
			case MasterPackage.GENERIC_FLOW__DATA_SIZE:
				return basicSetDataSize(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MasterPackage.GENERIC_FLOW__DESCRIPTION:
				return getDescription();
			case MasterPackage.GENERIC_FLOW__ALTERNATIVE_NAMES:
				return getAlternativeNames();
			case MasterPackage.GENERIC_FLOW__NAME:
				return getName();
			case MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				if (resolve) return getDestinationSoftwareComponent();
				return basicGetDestinationSoftwareComponent();
			case MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT:
				if (resolve) return getSourceSoftwareComponent();
				return basicGetSourceSoftwareComponent();
			case MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES:
				return getDestinationAddresses();
			case MasterPackage.GENERIC_FLOW__DATA_SIZE:
				return getDataSize();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MasterPackage.GENERIC_FLOW__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				getAlternativeNames().addAll((Collection<? extends String>)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__NAME:
				setName((String)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				setDestinationSoftwareComponent((SoftwareComponent)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT:
				setSourceSoftwareComponent((SoftwareComponent)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES:
				getDestinationAddresses().clear();
				getDestinationAddresses().addAll((Collection<? extends EntityAddress>)newValue);
				return;
			case MasterPackage.GENERIC_FLOW__DATA_SIZE:
				setDataSize((Dependency)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MasterPackage.GENERIC_FLOW__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case MasterPackage.GENERIC_FLOW__ALTERNATIVE_NAMES:
				getAlternativeNames().clear();
				return;
			case MasterPackage.GENERIC_FLOW__NAME:
				setName(NAME_EDEFAULT);
				return;
			case MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				setDestinationSoftwareComponent((SoftwareComponent)null);
				return;
			case MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT:
				setSourceSoftwareComponent((SoftwareComponent)null);
				return;
			case MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES:
				getDestinationAddresses().clear();
				return;
			case MasterPackage.GENERIC_FLOW__DATA_SIZE:
				setDataSize((Dependency)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MasterPackage.GENERIC_FLOW__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case MasterPackage.GENERIC_FLOW__ALTERNATIVE_NAMES:
				return alternativeNames != null && !alternativeNames.isEmpty();
			case MasterPackage.GENERIC_FLOW__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case MasterPackage.GENERIC_FLOW__DESTINATION_SOFTWARE_COMPONENT:
				return destinationSoftwareComponent != null;
			case MasterPackage.GENERIC_FLOW__SOURCE_SOFTWARE_COMPONENT:
				return sourceSoftwareComponent != null;
			case MasterPackage.GENERIC_FLOW__DESTINATION_ADDRESSES:
				return destinationAddresses != null && !destinationAddresses.isEmpty();
			case MasterPackage.GENERIC_FLOW__DATA_SIZE:
				return dataSize != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (description: ");
		result.append(description);
		result.append(", alternativeNames: ");
		result.append(alternativeNames);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //GenericFlowImpl
