/**
 */
package OMNET.impl;

import OMNET.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OMNETFactoryImpl extends EFactoryImpl implements OMNETFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static OMNETFactory init() {
		try {
			OMNETFactory theOMNETFactory = (OMNETFactory)EPackage.Registry.INSTANCE.getEFactory(OMNETPackage.eNS_URI);
			if (theOMNETFactory != null) {
				return theOMNETFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new OMNETFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OMNETFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case OMNETPackage.ROUTING_XML_ROUTE: return createRoutingXmlRoute();
			case OMNETPackage.ROUTING_XML_INTERFACE: return createRoutingXmlInterface();
			case OMNETPackage.ROUTING_XML_MULTICAST: return createRoutingXmlMulticast();
			case OMNETPackage.ROUTING_XML_FILE: return createRoutingXmlFile();
			case OMNETPackage.OMNETPP_INI_GROUP: return createOmnetppIniGroup();
			case OMNETPackage.OMNETPP_INI_LINE: return createOmnetppIniLine();
			case OMNETPackage.OMNETPP_INI_FILE: return createOmnetppIniFile();
			case OMNETPackage.NED_FILE: return createNedFile();
			case OMNETPackage.FILE_HEADER: return createFileHeader();
			case OMNETPackage.LOCAL_TYPE: return createLocalType();
			case OMNETPackage.INTERFACE_TYPE: return createInterfaceType();
			case OMNETPackage.MODULE_TYPE: return createModuleType();
			case OMNETPackage.CHANNEL: return createChannel();
			case OMNETPackage.CHANNEL_INTERFACE: return createChannelInterface();
			case OMNETPackage.SIMPLE_MODULE: return createSimpleModule();
			case OMNETPackage.MODULE_INTERFACE: return createModuleInterface();
			case OMNETPackage.COMPOUND_MODULE: return createCompoundModule();
			case OMNETPackage.NETWORK: return createNetwork();
			case OMNETPackage.GATE: return createGate();
			case OMNETPackage.MODULE_PARAM: return createModuleParam();
			case OMNETPackage.PROPERTY: return createProperty();
			case OMNETPackage.SIMPLE_PROPERTY: return createSimpleProperty();
			case OMNETPackage.MULTI_VALUE_PROPERTY: return createMultiValueProperty();
			case OMNETPackage.SINGLE_VALUE_PROPERTY: return createSingleValueProperty();
			case OMNETPackage.PROPERTY_DECLARATION: return createPropertyDeclaration();
			case OMNETPackage.PARAMETER: return createParameter();
			case OMNETPackage.VARIABLE: return createVariable();
			case OMNETPackage.SUB_MODULE: return createSubModule();
			case OMNETPackage.CONNECTIONS: return createConnections();
			case OMNETPackage.CONNECTION: return createConnection();
			case OMNETPackage.CONNECTION_ITEM: return createConnectionItem();
			case OMNETPackage.CHANNEL_CONNECTION_ITEM: return createChannelConnectionItem();
			case OMNETPackage.CONNECTION_GROUP: return createConnectionGroup();
			case OMNETPackage.FOR_LOOP: return createForLoop();
			case OMNETPackage.PORT_ID: return createPortID();
			case OMNETPackage.INPUT_GATE: return createInputGate();
			case OMNETPackage.OUTPUT_GATE: return createOutputGate();
			case OMNETPackage.IN_OUT_GATE: return createInOutGate();
			case OMNETPackage.STRING_PARAMETER: return createStringParameter();
			case OMNETPackage.INT_PARAMETER: return createIntParameter();
			case OMNETPackage.DOUBLE_PARAMETER: return createDoubleParameter();
			case OMNETPackage.BOOL_PARAMETER: return createBoolParameter();
			case OMNETPackage.INT_VARIABLE: return createIntVariable();
			case OMNETPackage.DOUBLE_VARIABLE: return createDoubleVariable();
			case OMNETPackage.BOOL_VARIABLE: return createBoolVariable();
			case OMNETPackage.STRING_VARIABLE: return createStringVariable();
			case OMNETPackage.SIMPLE_PORT: return createSimplePort();
			case OMNETPackage.ARRAY_PORT: return createArrayPort();
			case OMNETPackage.VAR_ARRAY_PORT: return createVarArrayPort();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case OMNETPackage.DIRECTION:
				return createDirectionFromString(eDataType, initialValue);
			case OMNETPackage.SELECTOR:
				return createSelectorFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case OMNETPackage.DIRECTION:
				return convertDirectionToString(eDataType, instanceValue);
			case OMNETPackage.SELECTOR:
				return convertSelectorToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutingXmlRoute createRoutingXmlRoute() {
		RoutingXmlRouteImpl routingXmlRoute = new RoutingXmlRouteImpl();
		return routingXmlRoute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutingXmlInterface createRoutingXmlInterface() {
		RoutingXmlInterfaceImpl routingXmlInterface = new RoutingXmlInterfaceImpl();
		return routingXmlInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutingXmlMulticast createRoutingXmlMulticast() {
		RoutingXmlMulticastImpl routingXmlMulticast = new RoutingXmlMulticastImpl();
		return routingXmlMulticast;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RoutingXmlFile createRoutingXmlFile() {
		RoutingXmlFileImpl routingXmlFile = new RoutingXmlFileImpl();
		return routingXmlFile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OmnetppIniGroup createOmnetppIniGroup() {
		OmnetppIniGroupImpl omnetppIniGroup = new OmnetppIniGroupImpl();
		return omnetppIniGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OmnetppIniLine createOmnetppIniLine() {
		OmnetppIniLineImpl omnetppIniLine = new OmnetppIniLineImpl();
		return omnetppIniLine;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OmnetppIniFile createOmnetppIniFile() {
		OmnetppIniFileImpl omnetppIniFile = new OmnetppIniFileImpl();
		return omnetppIniFile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NedFile createNedFile() {
		NedFileImpl nedFile = new NedFileImpl();
		return nedFile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FileHeader createFileHeader() {
		FileHeaderImpl fileHeader = new FileHeaderImpl();
		return fileHeader;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LocalType createLocalType() {
		LocalTypeImpl localType = new LocalTypeImpl();
		return localType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceType createInterfaceType() {
		InterfaceTypeImpl interfaceType = new InterfaceTypeImpl();
		return interfaceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModuleType createModuleType() {
		ModuleTypeImpl moduleType = new ModuleTypeImpl();
		return moduleType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Channel createChannel() {
		ChannelImpl channel = new ChannelImpl();
		return channel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ChannelInterface createChannelInterface() {
		ChannelInterfaceImpl channelInterface = new ChannelInterfaceImpl();
		return channelInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleModule createSimpleModule() {
		SimpleModuleImpl simpleModule = new SimpleModuleImpl();
		return simpleModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModuleInterface createModuleInterface() {
		ModuleInterfaceImpl moduleInterface = new ModuleInterfaceImpl();
		return moduleInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompoundModule createCompoundModule() {
		CompoundModuleImpl compoundModule = new CompoundModuleImpl();
		return compoundModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Network createNetwork() {
		NetworkImpl network = new NetworkImpl();
		return network;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Gate createGate() {
		GateImpl gate = new GateImpl();
		return gate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModuleParam createModuleParam() {
		ModuleParamImpl moduleParam = new ModuleParamImpl();
		return moduleParam;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Property createProperty() {
		PropertyImpl property = new PropertyImpl();
		return property;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleProperty createSimpleProperty() {
		SimplePropertyImpl simpleProperty = new SimplePropertyImpl();
		return simpleProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MultiValueProperty createMultiValueProperty() {
		MultiValuePropertyImpl multiValueProperty = new MultiValuePropertyImpl();
		return multiValueProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SingleValueProperty createSingleValueProperty() {
		SingleValuePropertyImpl singleValueProperty = new SingleValuePropertyImpl();
		return singleValueProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyDeclaration createPropertyDeclaration() {
		PropertyDeclarationImpl propertyDeclaration = new PropertyDeclarationImpl();
		return propertyDeclaration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Parameter createParameter() {
		ParameterImpl parameter = new ParameterImpl();
		return parameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Variable createVariable() {
		VariableImpl variable = new VariableImpl();
		return variable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SubModule createSubModule() {
		SubModuleImpl subModule = new SubModuleImpl();
		return subModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connections createConnections() {
		ConnectionsImpl connections = new ConnectionsImpl();
		return connections;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connection createConnection() {
		ConnectionImpl connection = new ConnectionImpl();
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConnectionItem createConnectionItem() {
		ConnectionItemImpl connectionItem = new ConnectionItemImpl();
		return connectionItem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ChannelConnectionItem createChannelConnectionItem() {
		ChannelConnectionItemImpl channelConnectionItem = new ChannelConnectionItemImpl();
		return channelConnectionItem;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConnectionGroup createConnectionGroup() {
		ConnectionGroupImpl connectionGroup = new ConnectionGroupImpl();
		return connectionGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ForLoop createForLoop() {
		ForLoopImpl forLoop = new ForLoopImpl();
		return forLoop;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PortID createPortID() {
		PortIDImpl portID = new PortIDImpl();
		return portID;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InputGate createInputGate() {
		InputGateImpl inputGate = new InputGateImpl();
		return inputGate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OutputGate createOutputGate() {
		OutputGateImpl outputGate = new OutputGateImpl();
		return outputGate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InOutGate createInOutGate() {
		InOutGateImpl inOutGate = new InOutGateImpl();
		return inOutGate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StringParameter createStringParameter() {
		StringParameterImpl stringParameter = new StringParameterImpl();
		return stringParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntParameter createIntParameter() {
		IntParameterImpl intParameter = new IntParameterImpl();
		return intParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DoubleParameter createDoubleParameter() {
		DoubleParameterImpl doubleParameter = new DoubleParameterImpl();
		return doubleParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolParameter createBoolParameter() {
		BoolParameterImpl boolParameter = new BoolParameterImpl();
		return boolParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IntVariable createIntVariable() {
		IntVariableImpl intVariable = new IntVariableImpl();
		return intVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DoubleVariable createDoubleVariable() {
		DoubleVariableImpl doubleVariable = new DoubleVariableImpl();
		return doubleVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BoolVariable createBoolVariable() {
		BoolVariableImpl boolVariable = new BoolVariableImpl();
		return boolVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StringVariable createStringVariable() {
		StringVariableImpl stringVariable = new StringVariableImpl();
		return stringVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimplePort createSimplePort() {
		SimplePortImpl simplePort = new SimplePortImpl();
		return simplePort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ArrayPort createArrayPort() {
		ArrayPortImpl arrayPort = new ArrayPortImpl();
		return arrayPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VarArrayPort createVarArrayPort() {
		VarArrayPortImpl varArrayPort = new VarArrayPortImpl();
		return varArrayPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Direction createDirectionFromString(EDataType eDataType, String initialValue) {
		Direction result = Direction.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDirectionToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Selector createSelectorFromString(EDataType eDataType, String initialValue) {
		Selector result = Selector.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSelectorToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OMNETPackage getOMNETPackage() {
		return (OMNETPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static OMNETPackage getPackage() {
		return OMNETPackage.eINSTANCE;
	}

} //OMNETFactoryImpl
