package dnibuilder

import java.io.FileOutputStream
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl

//import DNI


class DNIBuilder {
	def static void main(String[] args) {
		new DNIBuilder().buildDNI()
	}
	
	def buildDNI(){
		val dp = new DirectoryParser();
		var directory = ".";///Users/Piotr/kit-svn/papers-bitbucket/paper-1-traffic-model-extraction/data_felix/data"
		var list_of_files = dp.parse(directory);
		println("files "+list_of_files)
		
		if(list_of_files == null || list_of_files.size()==0){ 	//if there is no data, take the example file included in the project
			directory = "."
			list_of_files = dp.parse(directory);
			println("files "+list_of_files)
		}
		
		val cs = new CaseStudies();
		cs.read(list_of_files);
		cs.extractGenerators(directory);
		
		println("case studies "+cs.getCaseStudies)
		// parsing the Viliam's optuput ready now buid the DNI model instance
		
		if(cs.caseStudies.size()>0){
			val gen = new NetworkTrafficModelInstanceGenerator
			val niModel = gen.generate(cs.caseStudies.get(0))
			
			new XMIResourceImpl => [
				contents.add(niModel)
				save(new FileOutputStream("./generated-traffic-model.xmi"), null)
			]	
		}
		else{
			println("No case Studies found!")
		}
		

	}
	

}

//Flow, Generator, TS and SwCom should have IDs
